;	jrdLib v1.1 by [JRD]
;	[ 18/08/00 ]
;
; Ce fichier source appartient  JRD et ne doit pas tre modifi sans me prvenir.
; De mme, aucune des fonctions ne peut tre utilise en l'insrant dans un autre fichier.
; Mais les fonctions peuvent tre appeles et je vous conseille d'ailleurs vivement de les utiliser ; en particulier jrdlib::Input qui est bien plus puissante qui celle de userlib.
; Cette librairies est la premire version qui fonctionne ( si vous constater des bugs, me les rapporter prcismment, Merci ).
; D'autres versions vont suivre ( pour permettre plus facilement de retourner une varibale au tios, etc...)
; Ce fichier est fourni pour les programmeurs qui veulent s'amliorer ou qui dbutent.

; This source file belongs to JRD and mustn't be modified without asking me.
; Of course, none function can be used in an other prog in insering the code in it.
; But all functions can be called and I really advise you to use them in your progs ; particullary jrdlib::Input which is must better than userlib's one.
; This library is the first version which works ( if you find some bugs, bring them back to me, Thanks ).
; Others versions will follow ( to easier allow to return a variable to the tios, etc...)
; This file is joined for all programers who want to improve or who begin.
; I'm sorry but I haven't the time to make an english version -> on the next version, the language could be chosen. Waiting this version, english user are authorized to recompile the source code with english traduction.

; J'espre que cette librairie vous sera utile.
; I hope that this library will be usefull for you.

; Vous pouvez me contacter  :
; You can contact me at :
;	jrd.asm@wanadoo.fr



	include	"tios.h"
	include	"graphlib.h"
	include	"userlib.h"
	include	"jrdlib.h"

;	xdef	_library
	xdef	_main
	xdef	_exit
	xdef	_comment
	xdef	_ti89
	xdef	_ti92plus

	xdef	jrdlib@0000	; Version
	xdef	jrdlib@0001	; Input
	xdef	jrdlib@0002	; Find_Local
	xdef	jrdlib@0003	; Find_No_Local
	xdef	jrdlib@0004	; FindEntry

	xdef	jrdlib@0005	; InitArgs
	xdef	jrdlib@0006	; GetCurArgType
	xdef	jrdlib@0007	; GetStringLong
	xdef	jrdlib@0008	; GetStringArg
	xdef	jrdlib@0009	; GetIntArg
	xdef	jrdlib@000A	; NextArg

	xdef	jrdlib@000B	; Char

;**********************************************
;	MACROS
;**********************************************
; a0 pointe la string.
back	MACRO
	move.l	\1,a0
	cmp	#0,d5
	beq	\finback
	cmp	#257,d0
	bne	\finback
	sub.w	#1,d5
	add.w	d5,a0
	move.b	#0,(a0)
	move.w	#0,d0
	bra	loop
\finback:
	cmp	#257,d0
	bne	\finback2
	move.w	#0,d0
	bra	loop
\finback2:
	ENDM
;----------------------------------------------------------------------------
rempli	MACRO
	movem.l	d0-d4,-(a7)
	move.w	\1,d0
	move.w	\2,d1
	move.w	\3,d2
	move.w	\4,d3
	move.w	\5,d4
	jsr	graphlib::fill
	movem.l	(a7)+,d0-d4
	ENDM

_main:
	pea	_comment
	jsr	tios::ST_showHelp
	lea	4(a7),a7
	jsr	userlib::idle_loop
_exit:
	rts

;**********************************************
;	FONCTIONS
;**********************************************
jrdlib@0000:
	move.l	#$4A524400,d0
	move.b	#11,d0
	rts

;----------------------------------------------------------------------------
;	INPUT
;
; Input :
;	a0.l : pointe la string
;	d1.w : x
;	d2.w : y
;	d3.w : max (de 1  20)
;		Si le 1er octet de gauche et diffrent de 0,
;		alors les caractres peuvent tres de tout type (pas seulement ceux pour les fichiers).
;		Si le 2me octet de gauche et diffrent de 0,
;		alors les caractres affichs seront cet octet.
;	a1.l : label_ok
;	a2.l : label_cancel
; Output :
;	chane modifie et a1 pointe l'instruction suivante.
jrdlib@0001:
	movem.l	d0-d7/a3-a4,-(a7)

	move.w	#0,d5
	move.l	d3,d6
	swap	d6
	move.b	d6,char
	move.w	#$FF00,d7
	and.w	d6,d7	; d7 contient une valeur <>0 si 2nd + CHAR authoris.
	
	move.w	d3,d6
	lsl	#2,d6
	add.w	d3,d6
	add.w	d3,d6
	add.w	d3,d6
	move.l	a0,a3
	sub.w	#1,d3
loop:
	move.l	d1,-(a7)
	SetFont	#1
	move.l	(a7)+,d1
	sub.w	#2,d2
	rempli	d1,d2,d6,#10,#2
	add.w	#2,d2
	move.w	#20,d0
	move.l	a3,a0
	lea	str_input,a4
	cmp.b	#0,char
	bne	\copystr2
\copystr:
	move.b	(a0)+,(a4)+
	dbra.w	d0,\copystr
	bra	\fcopy
\copystr2:
	move.b	(char),(a4)+
	dbra.w	d0,\copystr2
\fcopy:
	lea	str_input,a4
	move.b	#124,0(a4,d5)
	move.b	#0,1(a4,d5)
	movem	d0-d2,-(a7)
	WriteStr	d1,d2,#0,str_input
	movem	(a7)+,d0-d2
	jsr	userlib::idle_loop
	cmp.w	#0,d7
	beq	\suitechar
	cmp.w	#Key2Char,d0
	bne	\suitechar
	bsr	Char2nd
	cmp.w	#0,d0
	beq	loop
\suitechar:
	cmp.w	#$410A,d0
	beq	\key_
	cmp.w	#$405E,d0
	beq	\keyTheta
\k_suite:
	back	a3
	cmp.w	#264,d0
	beq	\cancel
	cmp.w	#13,d0
	beq	\ok
	cmp.w	#263,d0
	beq	\Clear
	cmp.w	#255,d0
	bhi	loop
	cmp.w	#0,d0
	beq	loop
	cmp.w	d3,d5
	bhi	loop
	move.l	a3,a0
	add.w	d5,a0
	move.b	d0,(a0)
	add.b	#1,d5
	move.b	#0,1(a0)
	bra	loop
\key_:
	move.w	#95,d0
	bra	\k_suite
\keyTheta:
	move.w	#136,d0
	bra	\k_suite
\Clear:
	move.b	#0,(a3)
	move.b	#0,1(a3)
	move.w	#0,d5
	bra	loop
\ok:
	movem.l	(a7)+,d0-d7/a3-a4
	rts
\cancel:
	movem.l	(a7)+,d0-d7/a3-a4
	move.l	a2,a1
	rts
;----------------------------------------------------------------------------
;	FIND_IN_LOCAL
;
; input :	a0 :adresse de la string.
; output :
;	a0 pointe sur l'entr du fichier dans la VAT.
;	a0 contient 0 si l'entre n'existe pas.
jrdlib@0002:
	movem.l	a1/d1-d5,-(a7)
	move.l	a0,a1
	move.w	#FolderListHandle,d0
	DEREF	d0,a0
	add.w	#2,a0
	move.w	(a0),d3
	sub.w	#1,d3
	sub.w	#12,a0
	move.w	#0,d4
\l_loop1:
	add.w	#1,d4
	add.w	#14,a0
	cmp.b	#$30,(a0)
	beq	\l_loop1
	cmp.w	#1,d4
	beq	\paslocal		; si pas de rpertoire du genre 000x alors quitte.
	sub.w	#1,d4
	sub.w	#2,a0

	move.l	a1,-(a7)
	move.w	(a0),-(a7)
	bsr	FindEntry
	lea	6(a7),a7
	bra	\l_fin
\paslocal:
	sub.l	a0,a0
\l_fin:
	movem.l	(a7)+,a1/d1-d5
	rts
;----------------------------------------------------------------------------
;	FIND_NO_LOCAL
;
; input :	a0 :adresse de la string.
; output :
;	a0 pointe sur l'entr du fichier dans la VAT.
;	a0 contient 0 si l'entre n'existe pas.
jrdlib@0003:
	movem.l	a1-a2/d1-d5,-(a7)
	move.l	a0,a1
	move.w	#FolderListHandle,d0
	DEREF	d0,a0
	add.w	#2,a0
	move.w	(a0),d3
	sub.w	#1,d3
	sub.w	#12,a0
\l_loop1:
	add.w	#14,a0
	cmp.b	#$30,(a0)
	beq	\l_loop1
	sub.w	#2,a0
	move.l	a0,a2
\finrep:
	add.w	#14,a2
	move.l	a1,-(a7)
	move.w	(a2),-(a7)
	bsr	FindEntry
	lea	6(a7),a7
	cmp.l	#0,a0
	dbne	d3,\finrep
	cmp.l	#0,a0
	bne	\l_fin
	sub.l	a0,a0
\l_fin:
	movem.l	(a7)+,a1-a2/d1-d5
	rts
;----------------------------------------------------------------------------
;	FINDENTRY
;
; Fonction : trouver une chane dans la VAT.
; input :
; 	handle dans lequel chercher.	(le premier  mettre dans la pile)
;	adresse de la chane.	(le dernier dans la pile)
; output :
;	d0=index de la chane dans la structure.
;	a0=adresse de l'entre dans la VAT (pointeur sur le nom). Vaut 0 si pas trouv.
jrdlib@0004:
FindEntry:
	movem.l	a1-a6/d1-d7,-(a7)
	move.l	58(a7),a0
	move.w	56(a7),d0
	DEREF	d0,a1
	addq.l	#2,a1
	move.w	(a1)+,d2
	tst.w	d2
	beq	\pasFE
	clr.w	d6
\loopFE:
	movem.l	a0-a1,-(a7)
	jsr	tios::strcmp
	movem.l	(a7)+,a0-a1
	tst.w	d0
	beq	\endFE
	lea	14(a1),a1
	add.w	#1,d6
	dbra.w	d2,\loopFE
	bra	\endFE
\pasFE
	sub.l	a1,a1
\endFE:
	move.w	d6,d0
	move.l	a1,a0
	movem.l	(a7)+,a1-a6/d1-d7
	rts
;----------------------------------------------------------------------------
jrdlib@0005:
	move.l	a0,-(a7)
	move.l	tios::top_estack,a0
	move.l	a0,ptr_DebutArgs
	move.l	a0,ptr_CurArgs
	move.l	(a7)+,a0
	rts
;----------------------------------------------------------------------------
jrdlib@0006:
	move.l	a0,-(a7)
	move.l	(ptr_CurArgs),a0
	move.b	(a0),d0
	move.l	(a7)+,a0
	rts
;----------------------------------------------------------------------------
jrdlib@0007:
	movem.l	a0-a1,-(a7)
	move.l	(ptr_CurArgs),a0
	move.b	(a0),d0
	cmp.b	#$2D,d0
	bne	\notstr
	clr.w	d1
	sub.w	#1,a0		; a0 pointe sur le zero de fin de chane.
\findzero:
	add.w	#1,d1
	sub.w	#1,a0		; a0 pointe sur le dernier cara en dcrmentant.
	cmp.b	#0,(a0)
	bne	\findzero		; a0 pointe sur le zero de dbut de chane.
	sub.w	#1,d1		; d1 contient le nombre de caractres.
	clr.b	d0		; indique que a a russi.
	bra	\fin
\notstr:
	move.b	#1,d0
\fin:
	movem.l	(a7)+,a0-a1
	rts
;----------------------------------------------------------------------------
jrdlib@0008:
	movem.l	a0-a2,-(a7)
	move.l	(ptr_CurArgs),a1
	move.b	(a1),d0
	cmp.b	#$2D,d0
	bne	\notstr
	sub.w	#1,a1		; a1 pointe sur le zero de fin de chane.
\findzero:
	sub.w	#1,a1		; a1 pointe sur le dernier cara en dcrmentant.
	cmp.b	#0,(a1)
	bne	\findzero		; a1 pointe sur le zero de dbut de chane.
	move.l	a0,a2
	add.w	#1,a1		; a1 pointe sur le dbut de chane.
\copy:
	move.b	(a1)+,(a2)+
	cmp.b	#0,(a1)
	bne	\copy		; recopie les cara jusqu'au marqueur de fin de chane.
	clr.b	(a2)		; met le 0 de fin de chane.
	move.l	a2,a0		; restaure a0 sur le dbut de la chane.
	clr.b	d0		; indique que a a russi.
	bra	\fin
\notstr:
	move.b	#1,d0
\fin:
	movem.l	(a7)+,a0-a2
	rts
;----------------------------------------------------------------------------
jrdlib@0009:
	movem.l	a1-a2/d2,-(a7)
	move.l	(ptr_CurArgs),a1
	move.b	(a1),d1
	cmp.b	#$1F,d1
	beq	\pos
	cmp.b	#$20,d1
	beq	\notint
\pos:
	sub.w	#1,a1		; a1 pointe sur le nombre de bytes pour former le nombre.
	move.b	(a1),d2
	cmp.b	d0,d2		; regarde si le nombre tient sur d0.b byte(s).
	bhi	\toobig		; sinon indique que le nombre est plus gros.
	sub.w	#4,a1		; dans tout les cas, retranche d'un long (double word).
				; met le nombre dans d1.l (mme si on ne considre qu'un byte).
	cmp.b	#0,d2
	bne	\s
	add.w	#1,a1		; considre le cas ou le nombre tient sur 0 octets (cad le nombre 0).
\s:
	lea	integer_temp,a2
	move.b	(a1)+,(a2)+
	move.b	(a1)+,(a2)+
	move.b	(a1)+,(a2)+
	move.b	(a1)+,(a2)+
	move.l	integer_temp,d1
				; ainsi il faut donc ne considrer que la partie demande.
	clr.b	d0		; indique que a a russi.
	bra	\fin
\notint:
	move.b	#1,d0
	bra	\fin
\toobig:
	move.b	#2,d0
\fin:
	movem.l	(a7)+,a1-a2/d2
	rts
;----------------------------------------------------------------------------
jrdlib@000A:
	movem.l	a0-a1/d1,-(a7)
	move.l	(ptr_CurArgs),a0
	move.b	(a0),d0		; d0 contient le type.
; les types grs sont $2D(string), $1F(positive integer), $20(negative integer), $2B(False), $2C(True),
; $D9(list), $D9D9(matrix).
	cmp.b	#$E5,d0		; regarde s'il n'y a plus d'argument.
	beq	nomorearg
	sub.w	#1,a0		; a0 pointe la dernire donne.
	cmp.b	#$2B,d0
	beq	metajour
	cmp.b	#$2C,d0
	beq	metajour
	cmp.b	#$2D,d0
	beq	string
	cmp.b	#$1F,d0
	beq	integ
	cmp.b	#$20,d0
	beq	integ
	cmp.b	#$D9,d0
	beq	list
	move.b	#2,d0
	bra	fin

string:
	sub.w	#1,a0		; a0 pointe le dernier caractre.
	cmp.b	#0,(a0)
	bne	string		; a0 pointe le 0.
	sub.w	#1,a0
	bra	metajour

integ:
	clr.l	d0
	move.b	(a0),d0
	add.w	#1,d0
	sub.w	d0,a0
	bra	metajour

list:
	cmp.b	#$D9,(a0)
	beq	matrix
\loop:
	sub.w	#1,a0
	cmp.b	#$E5,(a0)
	bne	\loop
	sub.w	#1,a0
	bra	metajour

matrix:
	sub.w	#1,a0
	cmp.w	#$E5E5,(a0)	; essaye de trouver les deux car de dbut de liste.
	bne	matrix
	sub.w	#1,a0
	bra	metajour

nomorearg:
	move.b	#1,d0
	bra	fin
metajour:
	move.l	a0,ptr_CurArgs
	cmp.b	#$E5,(a0)		; regarde s''il n'y a plus d'argument.
	beq	nomorearg
	clr.b	d0
fin:
	movem.l	(a7)+,a0-a1/d1
	rts
;----------------------------------------------------------------------------
initchars:
	movem.l	a0/d0,-(a7)
	lea	allchars,a0
	move.w	#0,d0
\loop:
	add.w	#1,d0
	cmp.w	#256,d0
	beq	\fin
	move.b	d0,(a0)+
	bra	\loop
\fin:
	move.b	#164,(cur)
	movem.l	(a7)+,a0/d0
	rts

jrdlib@000B:
Char2nd:
	movem.l	a0-a1/d1-d4,-(a7)
	bsr	initchars
	move.w	#2,d0		; ~16
	move.w	#25,d1
	move.w	#16,d2		; ~128
	move.w	#55,d3
	jsr	graphlib::scrtomem
	cmp.w	#0,d4
	beq	finchar
	lea	invite,a0
	move.w	#20,d0
	move.w	#25,d1
	move.w	#120,d2
	move.w	#50,d3
	jsr	graphlib::box
	SetFont	#1
	WriteStr	#46,#42,#4,cdn
	WriteStr	#46,#58,#4,cup
	WriteStr	#40,#50,#4,bande
LoopKey:
	rempli	#46,#50,#60,#7,#1
	move.b	#0,d0
	clr.w	d1
	move.b	(cur),d1
	lea	allchars,a0
	add.w	d1,a0
	sub.w	#1,a0
	lea	str,a1
\tronc:
	add.b	#1,d0
	move.b	(a0)+,(a1)+
	cmp.b	#10,d0
	beq	affbande
	cmp.b	#0,(a0)
	bne	\tronc
affbande:
	move.b	#0,(a1)
	WriteStr	#46,#50,#4,str
	jsr	userlib::idle_loop
	cmp.w	#264,d0
	beq	nochar
	cmp.w	#13,d0
	beq	charok
	cmp.w	#277,d0
	beq	k_Home
	cmp.w	#266,d0
	beq	k_Mode
	cmp.w	#338,d0		; 337 pour le GetKey
	beq	k_L
	cmp.w	#344,d0		; 340 pour le GetKey
	beq	k_R
	cmp.w	#4434,d0		; 4433 pour le GetKey
	beq	k_2L
	cmp.w	#4440,d0		; 4436 pour le GetKey
	beq	k_2R
	cmp.w	#32,d0
	bcs	LoopKey
	cmp.w	#255,d0
	bhi	LoopKey
	move.b	d0,(cur)
	bra	LoopKey
k_Home:
	move.b	#1,(cur)
	bra	LoopKey
k_Mode:
	move.b	#230,(cur)
	bra	LoopKey
k_L:
	sub.b	#1,(cur)
	cmp.b	#0,(cur)
	bne	\s
	move.b	#255,(cur)
\s:
	bra	LoopKey
k_R:
	add.b	#1,(cur)
	cmp.b	#0,(cur)
	bne	\s
	move.b	#1,(cur)
\s:
	bra	LoopKey
k_2L:
	sub.b	#9,(cur)
	cmp.b	#0,(cur)
	bne	\s
	move.b	#255,(cur)
\s:
	bra	LoopKey
k_2R:
	add.b	#9,(cur)
	cmp.b	#0,(cur)
	bne	\s
	move.b	#1,(cur)
\s:
	bra	LoopKey
charok:
	move.w	#2,d0		; ~16
	move.w	#25,d1
	move.w	#16,d2		; ~128
	move.w	#55,d3
	jsr	graphlib::memtoscr
	move.b	(cur),d0
	movem.l	(a7)+,a0-a1/d1-d4
	rts
nochar:
	move.w	#2,d0		; ~16
	move.w	#25,d1
	move.w	#16,d2		; ~128
	move.w	#55,d3
	jsr	graphlib::memtoscr
finchar:
	move.b	#0,d0
	movem.l	(a7)+,a0-a1/d1-d4
	rts
;----------------------------------------------------------------------------
_comment:	dc.b	"jrdLib ver 1.0 [19/08/00]",0
str_input		dcb.b	22,0
char		dc.b	0
ptr_DebutArgs	dc.l	0
ptr_CurArgs	dc.l	0
integer_temp	dc.l	0
invite		dc.b	"Select a char (Use ",17," / ",18,")",0
cdn		dc.b	20,0
cup		dc.b	19,0
bande		dc.b	25,32,32,32,32,32,32,32,32,32,32,26,0
allchars		dcb.b	256,0
cur		dc.w	0
str		dcb.b	11,0
	END